// functions to draw and fill a single rock bed
#include <u.h>
#include <libc.h>
#include <stdio.h>
#include <psgen.h>
#include "sg.h"


void draw_bed(PSDoc *ps, float thickness,  int hardness) {
	float width, xhandle, yhandle, xxx, yyy;

	PS_setlinewidth(ps, linewidth);
	PS_setmiterlimit(ps, 1);
	width=W*(1+C4*hardness);
	xxx=C2*W;
	xhandle=C3*xxx;
	yyy=C*thickness;
	yhandle=C3*yyy;
	if(hardness == 0) {
		xhandle=0;
		xxx=0;
	}
	if(hardness < 0) {
		xhandle=-xhandle;
		xxx=-xxx;
	}
	PS_moveto(ps, 0, 0);
	PS_lineto(ps, width, 0);
	PS_curveto(ps, width+xhandle, 0, width+xxx, yyy-yhandle, width+xxx, yyy);
	PS_lineto(ps, width+xxx, thickness-yyy);
	PS_curveto(ps, width+xxx, thickness-yyy+yhandle, width+xhandle, thickness, width, thickness);
	PS_lineto(ps, 0, thickness);
	PS_lineto(ps, 0, 0);
	PS_closepath(ps);
}

void create_bed(PSDoc *ps, float llx, float lly, float thickness,  int hardness, int patt) {
	PS_save(ps);
	PS_translate(ps, llx, lly);

	// fill with (color) pattern
	PS_setcolor(ps, "both", "pattern", (float) patt, 0.0, 0.0, 0.0);
	draw_bed(ps,  thickness,  hardness);
	PS_fill(ps);

	// draw outline
	PS_setcolor(ps, "stroke", "gray", 0.0, 0.0, 0.0, 0.0);
	draw_bed(ps,  thickness,  hardness);
	PS_stroke(ps);
	PS_restore(ps);
}


