// functions to define hatches and to compose pattern fill
#include <u.h>
#include <libc.h>
#include <stdio.h>
#include <psgen.h>
#include "sg.h"

extern PSDoc *ps;

void create_patterns(PSDoc *ps, int *pspatterns, Spotcolor *spotcolors, Rocktype *rocktypes)
{
	int i, j;
	void empty(PSDoc *ps);
	void crosses(PSDoc *ps);
	void rain(PSDoc *ps);
	void bricks(PSDoc *ps);
	void dots(PSDoc *ps);
	void circles(PSDoc *ps);
	void shortlines(PSDoc *ps);
	void chessboard(PSDoc *ps);

	void (*fp[HATCHES]) (PSDoc *ps);


	fp[0] = empty; /* address of fn empty() */
	fp[1] = crosses;
	fp[2] = rain; 
	fp[3] = bricks; 
	fp[4] = dots; 
	fp[5] = circles; 
	fp[6] = shortlines; 
	fp[7] = chessboard; 


	for(i=0; i<NUMROCKS; i++) {

		// compose pattern from fill-color and hatch
		pspatterns[i] = PS_begin_pattern(ps, 10.0, 10.0, 10.0, 10.0, 1);
	PS_setlinewidth(ps, 0.2*linewidth);

		// set rock's fill color
		j = rocktypes[i].fill; 
		PS_setcolor(ps, "both", "spot", (float) spotcolors[j].id, 1.0, 0.0, 0.0);
		PS_rect(ps, 0, 0, 10, 10);
		PS_fill(ps);

		// set rock's hatch
		j = rocktypes[i].hatch;

		(*fp[j]) (ps);  // pattern function call
	PS_setlinewidth(ps, linewidth);

		PS_end_pattern(ps);
	}
}

void empty(PSDoc *ps) {
	PS_setcolor(ps, "stroke", "gray", 0.0, 0.0, 0.0, 0.0);
}

void crosses(PSDoc *ps) {
	PS_setcolor(ps, "stroke", "gray", 0.0, 0.0, 0.0, 0.0);
	PS_moveto(ps, 2, 2);
	PS_lineto(ps, 8, 8);
	PS_stroke(ps);
	PS_moveto(ps, 8, 2);
	PS_lineto(ps, 2, 8);
	PS_stroke(ps);
}

void rain(PSDoc *ps) {
	PS_setcolor(ps, "stroke", "gray", 0.0, 0.0, 0.0, 0.0);
	PS_moveto(ps, 2, 2);
	PS_lineto(ps, 8, 8);
	PS_stroke(ps);
}

void bricks(PSDoc *ps) {
	PS_setcolor(ps, "stroke", "gray", 0.0, 0.0, 0.0, 0.0);
	PS_moveto(ps, 0, 0);
	PS_lineto(ps, 10, 0);
	PS_stroke(ps);
	PS_moveto(ps, 5, 0);
	PS_lineto(ps, 5, 5);
	PS_stroke(ps);
	PS_moveto(ps, 0, 5);
	PS_lineto(ps, 10, 5);
	PS_stroke(ps);
	PS_moveto(ps, 0, 5);
	PS_lineto(ps, 0, 10);
	PS_stroke(ps);
	PS_moveto(ps, 10, 5);
	PS_lineto(ps, 10, 10);
	PS_stroke(ps);
}

void dots(PSDoc *ps) {
	PS_setcolor(ps, "fill", "gray", 0.0, 0.0, 0.0, 0.0);
	PS_circle(ps, 1.5, 2.5, 1);
	PS_fill(ps);
	PS_circle(ps, 6.5, 2.5, 1);
	PS_fill(ps);
	PS_circle(ps, 4, 7.5, 1);
	PS_fill(ps);
	PS_circle(ps, 9, 7.5, 1);
	PS_fill(ps);
}

void circles(PSDoc *ps) {
	PS_setcolor(ps, "stroke", "gray", 0.0, 0.0, 0.0, 0.0);
	PS_circle(ps, 1.5, 2.5, 1);
	PS_stroke(ps);
	PS_circle(ps, 6.5, 2.5, 1);
	PS_stroke(ps);
	PS_circle(ps, 4, 7.5, 1);
	PS_stroke(ps);
	PS_circle(ps, 9, 7.5, 1);
	PS_stroke(ps);
}

void shortlines(PSDoc *ps) {
	PS_setcolor(ps, "stroke", "gray", 0.0, 0.0, 0.0, 0.0);
	PS_moveto(ps, 0, 2.5);
	PS_lineto(ps, 7.5, 2.5);
	PS_stroke(ps);
	PS_moveto(ps, 2.5, 7.5);
	PS_lineto(ps, 10, 7.5);
	PS_stroke(ps);
}

void chessboard(PSDoc *ps) {
	PS_setcolor(ps, "fill", "gray", 0.0, 0.0, 0.0, 0.0);
	PS_rect(ps, 5, 0, 10, 5);
	PS_fill(ps);
	PS_rect(ps, 0, 5, 5, 10);
	PS_fill(ps);
}

