// Main header file

#define LEFT_BORDER 30
#define BOTTOM_BORDER 20
#define H 20
#define W 100
#define C 0.15
#define C2 0.01
#define C3 0.4
#define C4 0.01
// 1 inch == 0.0254 m == 72 pt
// C5 == 72/0.0254 == 2834.645669291 [pt/m]
#define C5 2834.645669291
#define INVSCALE 50.0
#define LINEWIDTH 0.5
#define NUMCOLORS 10
#define NUMROCKS 11
#define HATCHES 8

typedef struct {
	int id;
	char name[32];
	char colorspace[10];
	float c1;
	float c2;
	float c3;
	float c4;
} Spotcolor;

typedef struct {
	int id;
	char name[32];
	int fill;
	int hatch;
	int hardness;
} Rocktype ;

void draw_bed(PSDoc *ps, float thickness,  int hardness);
void create_bed(PSDoc *ps, float llx, float lly, float thickness,  int hardness, int patt);
void create_patterns(PSDoc *ps, int *pspatterns, Spotcolor *spotcolors, Rocktype *rocktypes);

extern float linewidth;
extern int pspatterns[HATCHES];


